> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getunleash.io/api/create-group/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server. # Create a new group POST https://app.unleash-instance.example.com/api/admin/groups Content-Type: application/json **Enterprise feature** Create a new user group for Role-Based Access Control Reference: https://docs.getunleash.io/api/create-group ## Authentication - `Authorization` header (required) — API key needed to access this API - `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format ## Request ### Body (application/json) This endpoint expects a createGroupSchema. - `name` (string, required) — The name of the group - `description` (string, optional, nullable) — A custom description of the group - `mappingsSSO` (list of string, optional) — A list of SSO groups that should map to this Unleash group - `rootRole` (double, optional, nullable) — A role id that is used as the root role for all users in this group. This can be either the id of the Viewer, Editor or Admin role. - `users` (list of CreateGroupSchemaUsersItems, optional) — A list of users belonging to this group ## Response ### 201 The resource was successfully created. - `name` (string, required) — The name of the group - `id` (integer, optional) — The group id - `description` (string, optional, nullable) — A custom description of the group - `mappingsSSO` (list of string, optional) — A list of SSO groups that should map to this Unleash group - `rootRole` (double, optional, nullable) — A role id that is used as the root role for all users in this group. This can be either the id of the Viewer, Editor or Admin role. - `createdBy` (string, optional, nullable) — A user who created this group - `createdAt` (string, optional, nullable) — When was this group created - `projects` (list of string, optional) — A list of projects where this group is used - `userCount` (integer, optional) — The number of users that belong to this group - `scimId` (string, optional, nullable) — The SCIM ID of the group, only present if managed by SCIM ## Errors ### 400 Bad Request Error The request data does not match what we expect. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 401 Unauthorized Error Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 403 Forbidden Error The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 409 Conflict Error The provided resource can not be created or updated because it would conflict with the current state of the resource or with an already existing resource, respectively. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ## Types ### CreateGroupSchemaUsersItems A minimal user object - `user` (CreateGroupSchemaUsersItemsUser, required) — A minimal user object ### CreateGroupSchemaUsersItemsUser A minimal user object - `id` (integer, required) — The user id ## Examples **Request** ```json { "name": "DX team" } ``` **Response** ```json { "name": "DX team", "id": 1, "description": "Current members of the DX squad", "mappingsSSO": [ "SSOGroup1", "SSOGroup2" ], "rootRole": 1, "createdBy": "admin", "createdAt": "2023-06-30T11:41:00.123Z", "projects": [ "default", "my-project" ], "userCount": 1, "scimId": "01HTMEXAMPLESCIMID7SWWGHN7" } ``` **SDK Code** ```python import requests url = "https://app.unleash-instance.example.com/api/admin/groups" payload = { "name": "DX team" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/groups'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"name":"DX team"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/groups" payload := strings.NewReader("{\n \"name\": \"DX team\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/groups") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"DX team\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/groups") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"DX team\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/groups', [ 'body' => '{ "name": "DX team" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/groups"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"DX team\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = ["name": "DX team"] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/groups")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```